/*
** Dooble - The Secure Internet Web Browser
**
** Copyright (c) 2008, 2009, 2010, 2011, 2012 Alexis Megas.
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
** 3. The name of the author may not be used to endorse or promote products
**    derived from Dooble without specific prior written permission.
**
** DOOBLE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
** IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
** IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
** INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
** NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
** DOOBLE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef _dwebview_h_
#define _dwebview_h_

#ifndef DOOBLE_USE_QGRAPHICSWEBVIEW
#include <QWebView>
#else
#include <QGraphicsWebView>
#endif

#ifdef DOOBLE_USE_QGRAPHICSWEBVIEW
class QGraphicsItem;
class QGraphicsView;
class QGraphicsScene;
#endif

#ifndef DOOBLE_USE_QGRAPHICSWEBVIEW
class dwebview: public QWebView
#else
class dwebview: public QGraphicsWebView
#endif
{
  Q_OBJECT

 public:
#ifndef DOOBLE_USE_QGRAPHICSWEBVIEW
  dwebview(QWidget *parent);
#else
  dwebview(QGraphicsItem *parent);
#endif
  bool checkAndClearPopup(void);
  Qt::MouseButton mouseButtonPressed(void) const;

 private:
  bool m_allowPopup;
  Qt::MouseButton m_lastButtonPressed;
#ifndef DOOBLE_USE_QGRAPHICSWEBVIEW
  void mousePressEvent(QMouseEvent *event);
#else
  void mousePressEvent(QGraphicsSceneMouseEvent *event);
#endif

 private slots:
  void slotLoadStarted(void);
};

#endif
